Attribute VB_Name = "modHook"
Option Explicit

Private Declare Function SetWindowsHookEx Lib "user32.dll" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function GetClassName Lib "user32.dll" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32.dll" (ByVal hHook As Long) As Long
Private Declare Function SetWindowPos Lib "user32.dll" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Type CWPSTRUCT
    lParam As Long
    wParam As Long
    message As Long
    hWnd As Long
End Type

Private Const WH_CALLWNDPROC As Long = 4&

Private m_X As Long
Private m_Y As Long
Private m_hHook As Long

Public Sub Hook(ByVal ThreadID As Long, ByVal X As Long, ByVal Y As Long)
    m_hHook = SetWindowsHookEx(WH_CALLWNDPROC, AddressOf DlgPosProc, 0, ThreadID)
    m_X = X
    m_Y = Y
End Sub

Public Sub Unhook()
    Call UnhookWindowsHookEx(m_hHook)
End Sub

Public Sub DlgPosProc(ByVal n As Long, ByVal wParam As Long, ByRef Inf As CWPSTRUCT)
    Dim ClassName As String * 6
    If Inf.message = 1 Then
        Call GetClassName(Inf.hWnd, ClassName, Len(ClassName))
        If Left$(ClassName, 6) = "#32770" Then
            Call SetWindowPos(Inf.hWnd, 0&, m_X, m_Y, 0&, 0&, 1&)
        End If
    End If
End Sub
